{***************************************************************
 *
 * Unit Name: REEdit
 * Purpose  : Regular Expression Edit
 * Author   : hubdog(Xing Chen)
 * BeginDate: 2001-9-13
 * EndDate  :
 * History  : 1.0a
 *            1.1a(õʽŵעУͬʱ
 *                 ؼĴϢͬʽ󶨣
 *            1.2a ڱʽгͬıʽ
 *            1.3a (עй򵼳Ϊļͽļ뵽ע)
 *            1.4a (ʽЧʱֹӵʽб)
 *            1.5a (CanEmptyEmpty)
 * 2001-10-19 1.6a ӦһУʽԺExpressionһ
 *                 ҪЧַġͬʱҪ޸Ա༭,ʹֶ֧ѡ趨
 *            1.7a дӶDelphi6֧֣ҪԱ༭棬ӦýԱ༭Ԫ
 *                 ͬؼԪ룬ͬʱעᵥԪҲ루ɣ
 *            1.8a Ҷƣ$ŵȵʾܱ༭)
              1.9a ַſ()
              Done: ɾͻ˼Ч? ļл˼ɾӦЧ
 ****************************************************************}

{$I CXDefine.inc}
unit REEdit;

interface

uses
  {$IFDEF CX_debug}udbg,{$ENDIF}Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, RegExpr; //, {$IFDEF CX_D5}Dsgnintf{$ELSE}DesignIntf{$ENDIF};

type
  TEditAlign = (eaLeft, eaRight);

  TREEdit = class(TCustomEdit)
  private
    //FValid: Boolean;
    // FExprValid:Boolean;
    FRegExpr: TRegExpr;
    FExpression: string;
    FErrorMessage: string;
    FCanEmpty: Boolean;
    FInputExpression: string;
    FAlign: TEditAlign;
    procedure SetExpression(const Value: string);
    function GetValid: Boolean;
    procedure SetErrorMessage(const Value: string);
    //function GetExprValid: Boolean;
    function GetEmpty: Boolean;
    procedure SetCanEmpty(const Value: Boolean);
    procedure SetInputExpression(const Value: string);
    procedure SetAlign(const Value: TEditAlign);
    { Private declarations }
  protected
    { Protected declarations }
    procedure ProcessInput(var Msg: TWMChar); message WM_Char;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure DoEnter; override;
    procedure DoExit; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function IsExprValid(Expr: string): Boolean; //ʽǷЧ
    property RegExpr: TRegExpr read FRegExpr; //ʽ
  published
    { Published declarations }
   // property ExprValid: Boolean read GetExprValid; //жʽǷЧ
    property Expression: string read FExpression write SetExpression; //
    property InputExpression: string read FInputExpression write
      SetInputExpression; //ʽУ飬ϱʽĲ
    property Valid: Boolean read GetValid; //Ƿʽ
    property ErrorMessage: string read FErrorMessage write SetErrorMessage;
    property CanEmpty: Boolean read FCanEmpty write SetCanEmpty default True;
    //ǷΪ
    property Empty: Boolean read GetEmpty; //ǷΪ
    //ЧʱҪʾĴϢ
    property EditAlign: TEditAlign read FAlign write SetAlign;
    //property DisplayTemplete:string;//:$xxx%s.xx
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BiDiMode;
    property BorderStyle;
    property CharCase;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

procedure Register;

implementation
//uses REProp;

procedure Register;
begin
  RegisterComponents('CXLib', [TREEdit]);
  //ȥPropertyEditorǸĳComponentEditor
end;

{ TREEdit }

constructor TREEdit.Create(AOwner: TComponent);
begin
  inherited;
  FRegExpr := TRegExpr.Create;
  FExpression := ''; //Ӧøֵһеַıʽ
  FCanEmpty := True; //Ϊ
  FAlign := eaLeft; //
end;

destructor TREEdit.Destroy;
begin
  FRegExpr.Free;
  inherited;
end;

function TREEdit.GetEmpty: Boolean;
begin
  Result := Text = '';
end;

{function TREEdit.GetExprValid: Boolean;
begin
  try
    if FExpression <> '' then
    begin
      FRegExpr.Expression:=FExpression;
      FRegExpr.Compile;
      Result := True;
    end;
  except
    Result := False;
  end;
end;}

function TREEdit.GetValid: Boolean;
begin
  //ʽΪʱΪЧ
  Result := False;
  if (not CanEmpty) and Empty then
    Result := False
  else if (Expression = '') then
    Result := True
  else if (Expression <> '') then
  begin
    FRegExpr.expression := FExpression;
    FRegExpr.compile;
    Result := FRegExpr.Exec(Text)
  end;
end;

procedure TREEdit.ProcessInput(var Msg: TWMChar);
var
  S: string;
begin
  //todo:жϻ˼ɾǰ
{$IFDEF CX_debug}
  Debugger.LogFmtMsg('CharCode:%d', [Msg.CharCode]);
{$ENDIF}
  S := Text + string(Chr(Msg.CharCode));
  if FInputExpression <> '' then
  begin
    //ûtry-exceptǼٶ϶Աͨ
    FRegExpr.Expression := FInputExpression;
    FRegExpr.Compile;
    if FRegExpr.Exec(S) then
      inherited
    else if Msg.CharCode=8 then//ɾ
      inherited
    else
      Msg.Result := 0;
  end
  else
    inherited;
end;

function TREEdit.IsExprValid(Expr: string): Boolean;
begin
  Result := False;
  if Expr <> '' then
  begin
    try
      FRegExpr.Expression := Expr;
      FRegExpr.compile;
      Result := True;
    except
    end;
  end;
end;

procedure TREEdit.SetCanEmpty(const Value: Boolean);
begin
  FCanEmpty := Value;
end;

procedure TREEdit.SetErrorMessage(const Value: string);
begin
  FErrorMessage := Value;
end;

procedure TREEdit.SetExpression(const Value: string);
begin
  //FRegExpr.Expression := Value;
  if FExpression = Value then
    Exit;
  if IsExprValid(Value) or (Value = '') then
    FExpression := Value
  else
    raise Exception.create('Invalid regular expression');
  //FRegExpr.Expression := FExpression;
end;

procedure TREEdit.SetInputExpression(const Value: string);
begin
  //FRegExpr.Expression := Value;
  if FInputExpression = Value then
    Exit;
  if IsExprValid(Value) or (Value = '') then
    FInputExpression := Value
  else
    raise Exception.create('Invalid input regular expression');
  //FRegExpr.Expression := FExpression;
end;

procedure TREEdit.SetAlign(const Value: TEditAlign);
begin
  if FAlign = Value then
    Exit;
  FAlign := Value;
  RecreateWnd;
end;

procedure TREEdit.CreateParams(var Params: TCreateParams);
begin
  inherited;
  if EditAlign = earight then
    Params.Style := Params.Style or ES_RIGHT;
end;

procedure TREEdit.DoEnter;
begin
  inherited;
  //ʱʾַȥ
end;

procedure TREEdit.DoExit;
begin
  inherited;
  //ʾַ
end;

end.
//ע;ʽ'bn''bbbnnbn'жΪȷַbug
//ҵĽ취^bn$ж
